
import javax.net.ssl.SSLContext;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;
import javax.net.ssl.SSLSocketFactory;
import javax.net.ssl.HttpsURLConnection;
import java.util.Properties;
import java.net.URL;
import java.net.URLConnection;
import java.io.InputStream;
import java.security.cert.X509Certificate;
import java.security.cert.CertificateException;

public class Example
{
    public static void main(String[] args) throws Exception
    {
        // Create a dummy X509TrustManager that will trust any server certificate
        // This is for example only and should not be used in production
        X509TrustManager tm = new X509TrustManager()
        {
            public void checkClientTrusted(X509Certificate[] x509Certs, String s) throws CertificateException
            {

            }

            public void checkServerTrusted(X509Certificate[] x509Certs, String s) throws CertificateException
            {

            }

            public X509Certificate[] getAcceptedIssuers()
            {
                return new X509Certificate[0];
            }
        };

        // Use the trust manager to get an SSLSocketFactory
        SSLContext sslContext = SSLContext.getInstance("TLS");
        sslContext.init(null, new TrustManager[] {tm}, null);
        SSLSocketFactory socketFactory = sslContext.getSocketFactory();

        String dropoffLocation = "https://localhost:9031/ext/ref/dropoff?attribute=value&attribute2=value2&foo=bar";
        URL dropUrl = new URL(dropoffLocation);
        URLConnection urlConnection = dropUrl.openConnection();
        HttpsURLConnection httpsURLConnection = (HttpsURLConnection) urlConnection;
        httpsURLConnection.setSSLSocketFactory(socketFactory);
        // HTTP basic is a pain client side in java because the core libraries don't have base 64 support so
        // use the special header values
        urlConnection.setRequestProperty("ping.uname", "changeme");
        urlConnection.setRequestProperty("ping.pwd", "please change me before you go into production!");
        // Get the response and parse it into a Properties object
        InputStream is = urlConnection.getInputStream();
        Properties p = new Properties();
        p.load(is);

        // Grab the value of the reference from the properties
        String referenceValue = p.getProperty("REF");

        // Call back to PF to get the attributes associated with the reference
        String pickupLocation = "https://localhost:9031/ext/ref/pickup?REF=" + referenceValue;
        System.out.println(pickupLocation);
        URL pickUrl = new URL(pickupLocation);
        URLConnection urlConn = pickUrl.openConnection();
        HttpsURLConnection httpsURLConn = (HttpsURLConnection) urlConn;
        httpsURLConn.setSSLSocketFactory(socketFactory);
        urlConn.setRequestProperty("ping.uname", "changeme");
        urlConn.setRequestProperty("ping.pwd", "please change me before you go into production!");
        // Get the response and parse it into a Properties object which are the 'user attributes'
        InputStream inputStream = urlConn.getInputStream();
        Properties props = new Properties();
        props.load(inputStream);
        System.out.println(props);
    }
}
