@echo off

rem -------------------------------------------------------------------------
rem JBoss Bootstrap Script for Win32
rem -------------------------------------------------------------------------
rem $Id: run.bat,v 1.13.4.1 2004/12/15 16:52:20 starksm Exp $
REM @if not "%ECHO%" == ""  echo %ECHO%
REM @if "%OS%" == "Windows_NT"  setlocal

set DIRNAME=.

if "%OS%" == "Windows_NT" set DIRNAME=%~dp0%
set PROGNAME=run.bat
if "%OS%" == "Windows_NT" set PROGNAME=%~nx0%

cd ..

set BASEDIR=%cd%\

cd bin

REM Read all command line arguments
REM
REM The %ARGS% env variable commented out in favor of using %* to include
REM all args in java command line. See bug #840239. [jpl]
REM
REM set ARGS=
REM :loop
REM if [%1] == [] goto endloop
REM         set ARGS=%ARGS% %1
REM         shift
REM         goto loop
REM :endloop

REM Find run.jar, or we can't continue

set RUNJAR=%DIRNAME%\run.jar

if exist "%RUNJAR%" goto FOUND_RUN_JAR
echo Could not locate %RUNJAR%. Please check that you are in the
echo bin directory when running this script.
goto END

:FOUND_RUN_JAR
REM Find the pf boot jar, or we can't continue
set RUNPFJAR=%DIRNAME%\pf-startup.jar

if exist "%RUNPFJAR%" goto FOUND_RUNPF_JAR
echo Could not locate %RUNPFJAR%. Please check that you are in the
echo bin directory when running this script.
goto END

:FOUND_RUNPF_JAR

if not "%JAVA_HOME%" == "" goto ADD_TOOLS
set JAVA=java
echo JAVA_HOME is not set.  Unexpected results may occur.
echo Set JAVA_HOME to the directory of your local JDK to avoid this message.
goto SKIP_TOOLS

:ADD_TOOLS

set JAVA=%JAVA_HOME%\bin\java
if exist "%JAVA_HOME%\lib\tools.jar" goto SKIP_TOOLS

echo Could not locate %JAVA_HOME%\lib\tools.jar. Unexpected results may occur.
echo Make sure that JAVA_HOME points to a JDK and not a JRE.

:SKIP_TOOLS

REM Include the JDK javac compiler for JSP pages. The default is for a Sun JDK
REM compatible distribution to which JAVA_HOME points

set JAVAC_JAR=%JAVA_HOME%\lib\tools.jar

REM If JBOSS_CLASSPATH is empty, don't include it, as this will 
REM result in including the local directory, which makes error tracking
REM harder.

set XMLBEANS_JAR=%BASEDIR%\server\default\lib\xmlbeans.jar
set PF_CONSOLE_UTILS=%DIRNAME%\pf-consoleutils.jar

set JBOSS_CLASSPATH=%JAVAC_JAR%;%RUNJAR%;%RUNPFJAR%;%XMLBEANS_JAR%;%PF_CONSOLE_UTILS%

REM Setup JBoss specific properties

set JAVA_OPTS=-Dprogram.name=%PROGNAME%
set JBOSS_HOME=%DIRNAME%

REM Sun JVM memory allocation pool parameters. Modify as appropriate.

set JAVA_OPTS=%JAVA_OPTS% -Xms128m -Xmx512m

REM JPDA options. Uncomment and modify as appropriate to enable remote debugging.
REM set JAVA_OPTS=-classic -Xdebug -Xnoagent -Djava.compiler=NONE -Xrunjdwp:transport=dt_socket,address=8787,server=y,suspend=y %JAVA_OPTS%
REM set JAVA_OPTS=-Xdebug -Xnoagent -Djava.compiler=NONE -Xrunjdwp:transport=dt_socket,address=8787,server=y,suspend=n %JAVA_OPTS%

REM Enable using jconsole to configure config stores
REM set JAVA_OPTS=-Dcom.sun.management.jmxremote %JAVA_OPTS%

REM Setup the java endorsed dirs

set JBOSS_ENDORSED_DIRS=%JBOSS_HOME%\lib\endorsed

if exist "%JBOSS_HOME%run.properties" (
	set JAVA_OPTS=%JAVA_OPTS% -Drun.properties=%JBOSS_HOME%run.properties
) ELSE (
	echo Missing %JBOSS_HOME%run.properties; using defaults.
)

echo ===============================================================================
echo .
echo   JBoss Bootstrap Environment
echo .
echo   JBOSS_HOME: %JBOSS_HOME%
echo .
echo   JAVA: %JAVA%
echo .
echo   JAVA_OPTS: %JAVA_OPTS%
echo .
echo   CLASSPATH: %JBOSS_CLASSPATH%
echo .
echo ===============================================================================
echo .

:RESTART

"%JAVA%" %JAVA_OPTS% "-Djava.endorsed.dirs=%JBOSS_ENDORSED_DIRS%" -classpath "%JBOSS_CLASSPATH%" org.pingidentity.RunPF %BASEDIR% %*

IF ERRORLEVEL 10 GOTO RESTART
:END

if "%NOPAUSE%" == "" pause

