<%
/*******************************************************************************
* Copyright (C) 2006 Ping Identity Corporation All rights reserved.
*
* This software is licensed under the Open Software License v2.1 (OSL v2.1).
*
* A copy of this license has been provided with the distribution of this
* software. Additionally, a copy of this license is available at:
* http://opensource.org/licenses/osl-2.1.php
*
******************************************************************************
*/
%>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1"
    pageEncoding="ISO-8859-1"%>
<%@ page import = "java.util.Properties" %>
<%@ page import = "java.util.Map" %>
<%@ page import = "java.util.HashMap" %>
<%@ page import = "java.util.ArrayList" %>
<%@ page import = "java.util.Enumeration" %>
<%@ page import = "java.util.Set" %>
<%@ page import = "java.util.Iterator" %>
<%@ page import = "java.util.Hashtable" %>
<%@ page import = "java.util.List" %>

<%@ page import = "java.io.IOException" %>
<%@ page import = "java.net.MalformedURLException" %>
<%@ page import = "java.net.URL" %>
<%@ page import = "java.rmi.RemoteException" %>

<%@ page import = "org.apache.axis.client.Call" %>
<%@ page import = "org.apache.axis.client.Service" %>

<%@ page import = "javax.xml.namespace.QName" %>
<%@ page import = "javax.xml.rpc.ServiceException" %>

<%@ page import = "com.pingidentity.ws.SSOEntity" %>

<%!
	final int MAX_LENGTH = 40;

	private  final String START_SSO        = "/startSSO.ping";          //$NON-NLS-1$
	private  final String START_SLO        = "/startSLO.ping";          //$NON-NLS-1$
	private  final String TARGET_SSO       = "/";           //$NON-NLS-1$
	private  final String TARGET_IDP_SLO   = "/";        //$NON-NLS-1$
	private  final String TARGET_SP_SLO    = "/";                   //$NON-NLS-1$
	private  final String ERROR_PAGE       = "/error.jsp?message=";     //$NON-NLS-1$
	private  final String JSP_DEFAULT      = "/index.jsp";      //$NON-NLS-1$
	private  final String JSP_LOGIN        = "/login.jsp?source=";      //$NON-NLS-1$
	private  final String JSP_ACCOUNT_LINK = "/accountlink.jsp?source=";//$NON-NLS-1$
	private  final String MAIN_PAGE        = "/mainpage.jsp";           //$NON-NLS-1$
	private  final String PARTNER_IDP_ID   = "PartnerIdpId";            //$NON-NLS-1$
	private  final String PARTNER_SP_ID    = "PartnerSpId";             //$NON-NLS-1$
	private  final String TARGET_RESOURCE  = "TargetResource";          //$NON-NLS-1$
	private  final String IN_ERROR_RESOURCE= "InErrorResource";         //$NON-NLS-1$
	private  final String IDP_ADAPTER_ID   = "IdpAdapterId"; 		  //$NON-NLS-1$
	private  final String SP_ADAPTER_ID    = "SpSessionAuthnAdapterId"; //$NON-NLS-1$
	private  final String IDP_SAMPLE_SSO   = "/SSOIdpServlet";          //$NON-NLS-1$
	private  final String IDP_SAMPLE_SLO   = "/SLOIdpServlet";          //$NON-NLS-1$
	private  final String SP_SAMPLE_SLO    = "/SLOSpServlet";           //$NON-NLS-1$
	private  final String IDP_DIR          = "/idp";                    //$NON-NLS-1$
	private  final String SP_DIR           = "/sp";                     //$NON-NLS-1$
	private  final String SP_DEFEDERATE    = "/sp/defederate.ping";     //$NON-NLS-1$

	public final String INIT_PARAM_USERS_FILE      = "users-props-file";
	public final String INIT_PARAM_CONFIG_FILE     = "config-file";
	public final String INIT_PARAM_CONNECTIONS_FILE = "connections-file";
	public final String INIT_PARAM_PROPERTIES_FILE = "pfagent-properties";
	public final String INIT_PARAM_CONFIG_PATH     = "config-path";

	public final String USER_SESSION_ID = "userSessionID";  //$NON-NLS-1$
   	public final String RESUME_PATH    = "resumePath";   //$NON-NLS-1$
	public final String USER_INFO      = "userInfo";     //$NON-NLS-1$
	public final String ATTRIBUTE_NAMES_LIST  = "attributeNamesList";
	public final String ATTRIBUTE_VALUES_LIST = "attributeValuesList";
	public final String USER_NAME  = "userName";
	public final String PASSWORD = "password";
	public final String USER_ID        = "userId";
	public final String COOKIE = "cookie";
	public final String QUERY  = "query";
	public final String LOGIN_SOURCE = "main";    //$NON-NLS-1$

	public final String PARAM_CMD = "cmd";
	public final String PARAM_CMD_SSO = "sso";
	public final String PARAM_CMD_SLO = "slo";
	public final String PARAM_CMD_ACCOUNT_LINK = "accountlink";
	public final String PARAM_CMD_LOGOUT = "logout";
	public final String PARAM_CMD_POST_LOGIN = "postlogin";
	public final String PARAM_CMD_POST_LOGIN_ACCOUNT_LINK = "postloginaccountlink";
	public final String PARAM_CMD_DEFAULT = "default";

	public final String AUTHN_CTX_ATTRIBUTE_NAME = "authnContext";

	protected String hostPF;
	protected String hostPFIdp;
	protected String hostPFSp;
	protected String hostAppIdp;
	protected String hostAppSp;
	protected String partnerIdpId;
	protected String partnerSpId;
	protected String spSessionAuthnAdapterId;

	public String configFilePath;
	public String connectionsFilePath;
	public String usersFilePath;
	public String propertiesFilePath;

	public final String WS_METHOD_GETIDPLIST = "getIDPList"; 
	public final String WS_METHOD_GETSPLIST = "getSPList"; 
	public final String NAMESPACE_AXIS_BEAN_SERVICE = "urn:BeanService";
	public final String NAMESPACE_PFWS = "http://www.pingidentity.com/services/SSODirectoryService";
	public final String SSOENTITY = "SSOEntity";
	public final String WS_URI = "/pf-ws/services/SSODirectoryService";
	public final String ATTRIB_NAME_IDPLIST = "idplist";
	public final String ATTRIB_NAME_SPLIST = "splist";
	public final String ATTRIB_NAME_ERROR = "error";
    
	public Service service = new Service();


	public void loadGlobalProperties(ServletConfig config, HttpServletRequest request) throws IOException {
		String configFileName      = config.getServletContext().getInitParameter(INIT_PARAM_CONFIG_FILE);       //$NON-NLS-1$
		String connectionsFileName = config.getServletContext().getInitParameter(INIT_PARAM_CONNECTIONS_FILE);  //$NON-NLS-1$
		String usersFileName = config.getServletContext().getInitParameter(INIT_PARAM_USERS_FILE);  //$NON-NLS-1$
		String propertiesFileName = config.getServletContext().getInitParameter(INIT_PARAM_PROPERTIES_FILE);  //$NON-NLS-1$
		String configPath          = config.getServletContext().getInitParameter(INIT_PARAM_CONFIG_PATH);       //$NON-NLS-1$

		configFilePath = config.getServletContext().getRealPath(
				configPath + configFileName);
		connectionsFilePath = config.getServletContext().getRealPath(
				configPath + connectionsFileName);
		usersFilePath = config.getServletContext().getRealPath(
				configPath + usersFileName);
		propertiesFilePath = config.getServletContext().getRealPath(
				configPath + propertiesFileName);

		Properties configProperties = getProperties(configFilePath);

		this.hostPF	      = configProperties.getProperty("hostPF");       //$NON-NLS-1$
		this.hostAppIdp = request.getScheme() + "://" + request.getServerName() + ":" + request.getServerPort() + request.getContextPath();
		this.hostAppSp = request.getScheme() + "://" + request.getServerName() + ":" + request.getServerPort() + request.getContextPath();
		this.partnerIdpId = configProperties.getProperty("partnerIdpId"); //$NON-NLS-1$
		this.partnerSpId  = configProperties.getProperty("partnerSpId");  //$NON-NLS-1$
		this.spSessionAuthnAdapterId = configProperties.getProperty("spSessionAuthnAdapterId"); //$NON-NLS-1$

		this.hostPFIdp = this.hostPF + this.IDP_DIR;
		this.hostPFSp  = this.hostPF + this.SP_DIR;
	}

	public  String getIdpStartSSOUrl(Boolean forceAuthn, Boolean isPassive) {

		//create url to SSOIdpServlet for starting IdP initiated SSO
		String url = this.hostAppIdp + "?" + this.PARAM_CMD + "=" + this.PARAM_CMD_SSO + "&resumePath=" + this.IDP_DIR + this.IDP_SAMPLE_SSO;

		//add ForceAuthn and IsPassive parameters if it is necessary
		String params = addParameters(forceAuthn, isPassive);
		if(params != null) {
			url += "?" + params; //$NON-NLS-1$
		}
		return url;
	}

	public  String getIdpStartSSOUrl(String partnerSpId, String TargetResource, String idpAdapterId, Boolean forceAuthn, Boolean isPassive) {

		//create url to Pingfederate IdP Start SSO service
		String url = this.hostAppIdp + "?" + this.PARAM_CMD + "=" + this.PARAM_CMD_SSO + "&resumePath=" + IDP_DIR + START_SSO + "?" 
				+ PARTNER_SP_ID + "=" +  partnerSpId + "&"
				+ IDP_ADAPTER_ID + "=" +  idpAdapterId + "&"
				+ TARGET_RESOURCE + "=" + TargetResource;

		//add ForceAuthn and IsPassive parameters if it is necessary
		String params = addParameters(forceAuthn, isPassive);
		if(params != null) {
			url += "?" + params; //$NON-NLS-1$
		}
		return url;
	}

	public  String getIdpStartSSOUrl(String partnerSpId, String TargetResource, Boolean forceAuthn, Boolean isPassive) {

		//create url to Pingfederate IdP Start SSO service
		String url = this.hostAppIdp + "?" + this.PARAM_CMD + "=" + this.PARAM_CMD_SSO + "&resumePath=" + IDP_DIR + START_SSO + "?" 
				+ PARTNER_SP_ID + "=" +  partnerSpId + "&"
				+ TARGET_RESOURCE + "=" + TargetResource; 

		//add ForceAuthn and IsPassive parameters if it is necessary
		String params = addParameters(forceAuthn, isPassive);
		if(params != null) {
			url += "?" + params; //$NON-NLS-1$
		}
		return url;
	}

	public  String getIdpStartSSOUrl(String partnerSpId, Boolean forceAuthn, Boolean isPassive) {

		//create url to Pingfederate IdP Start SSO service
		String url = this.hostAppIdp + "?" + this.PARAM_CMD + "=" + this.PARAM_CMD_SSO + "&resumePath=" + IDP_DIR + START_SSO + "?" 
				+ PARTNER_SP_ID + "=" +  partnerSpId;

		//add ForceAuthn and IsPassive parameters if it is necessary
		String params = addParameters(forceAuthn, isPassive);
		if(params != null) {
			url += "?" + params; //$NON-NLS-1$
		}
		return url;
	}


	public  String getSpStartSSOUrl(Boolean forceAuthn, Boolean isPassive) {

		//create url to Pingfederate SP Start SSO service
		String url = hostPFSp + START_SSO + "?" + PARTNER_IDP_ID + "=" +          //$NON-NLS-1$//$NON-NLS-2$
	      partnerIdpId + "&" + SP_ADAPTER_ID + "=" + spSessionAuthnAdapterId +   //$NON-NLS-1$//$NON-NLS-2$
	      "&" + TARGET_RESOURCE + "=" + hostAppSp + TARGET_SSO;                  //$NON-NLS-1$//$NON-NLS-2$

		//add ForceAuthn and IsPassive parameters if it is necessary
		String params = addParameters(forceAuthn, isPassive);
	   if(params != null) {
	      url += "&" + params; //$NON-NLS-1$
	   }
	   return url;
	}

	public  String getSpStartSSOUrl(String partnerIdpId, String spSessionAuthnAdapterId, Boolean forceAuthn, Boolean isPassive) {
		//create url to Pingfederate SP Start SSO service
		String url = hostPFSp + START_SSO + "?" + PARTNER_IDP_ID + "=" +          //$NON-NLS-1$//$NON-NLS-2$
	      partnerIdpId + "&" + SP_ADAPTER_ID + "=" + spSessionAuthnAdapterId +   //$NON-NLS-1$//$NON-NLS-2$
	      "&" + TARGET_RESOURCE + "=" + hostAppSp + TARGET_SSO;                  //$NON-NLS-1$//$NON-NLS-2$

		//add ForceAuthn and IsPassive parameters if it is necessary
		String params = addParameters(forceAuthn, isPassive);
	   if(params != null) {
	      url += "&" + params; //$NON-NLS-1$
	   }
	   return url;
	}

	public  String getSpStartSSOUrl(String partnerIdpId, Boolean forceAuthn, Boolean isPassive) {
		//create url to Pingfederate SP Start SSO service
		String url = hostPFSp + START_SSO + "?" + PARTNER_IDP_ID + "=" + partnerIdpId + 
	      	"&" + TARGET_RESOURCE + "=" + hostAppSp + TARGET_SSO;          

		//add ForceAuthn and IsPassive parameters if it is necessary
		String params = addParameters(forceAuthn, isPassive);
		if(params != null) {
			url += "&" + params; //$NON-NLS-1$
		}
		return url;
	}


	public  String getIdpStartSLOUrl() {

		//create url to SLOIdpServlet for starting IdP initiated SLO
	   String url = hostAppIdp + IDP_SAMPLE_SLO;
	   return url;
	}

	public  String getSpStartSLOUrl() {

		//create url to SLOSpServlet for starting SP initiated SLO
	   String url = hostAppSp + SP_SAMPLE_SLO;
	   return url;
	}

	public  String getIdpSSOLink() {

		//create url to Pingfederate IdP Start SSO service
	   String url = hostPFIdp + START_SSO + "?" + PARTNER_SP_ID + "=" +          //$NON-NLS-1$//$NON-NLS-2$
	      partnerSpId + "&" + TARGET_RESOURCE + "=" + hostAppSp + TARGET_SSO;    //$NON-NLS-1$//$NON-NLS-2$
	   return url;
	}

	public  String getIdpSSOLink(String partnerSpId, String TargetResource) {

		//create url to Pingfederate IdP Start SSO service
	   String url = hostPFIdp + START_SSO + "?" + PARTNER_SP_ID + "=" +          //$NON-NLS-1$//$NON-NLS-2$
	   partnerSpId + "&" + TARGET_RESOURCE + "=" + TargetResource;    //$NON-NLS-1$//$NON-NLS-2$
	   return url;
	}

	public  String getIdpSLOLink() {

		//create url to Pingfederate IdP Start SLO service
		String url = hostPFIdp + START_SLO + "?" + TARGET_RESOURCE + "=" +          //$NON-NLS-1$//$NON-NLS-2$
	      hostAppIdp + TARGET_IDP_SLO;//$NON-NLS-1$//$NON-NLS-2$
	   return url;
	}

	public  String getSpSLOLink() {

		//create url to Pingfederate SP Start SLO service
		String url = hostPFSp + START_SLO + "?" + TARGET_RESOURCE + "=" + hostAppSp + TARGET_SP_SLO;               //$NON-NLS-1$//$NON-NLS-2$
	   return url;
	}

	public  String getIdpHomeUrl() {

		//create url to IdP index.jsp
		String url = hostAppIdp;
		return url;
	}

	public  String getSpHomeUrl() {

		//create url to SP index.jsp
		String url = hostAppSp;
		return url;
	}

	public String getIdpErrorPageUrl() {

		//create url to error page on the IdP part of the Sample Application
		//this url allows to add some message to be shown on the error page
		String url = hostAppIdp + ERROR_PAGE;
		return url;
	}

	public String getSpErrorPageUrl() {

		//create url to error page on the SP part of the Sample Application
		//this url allows to add some message to be shown on the error page
		String url = hostAppSp + ERROR_PAGE;
		return url;
	}

	public String getIdpMainPageUrl() {

		//create url to mainpage.jsp on the IdP part of the Sample Application
		String url = hostAppIdp + MAIN_PAGE;
		return url;
	}

	public String getSpMainPageUrl() {

		//create url to mainpage.jsp on the SP part of the Sample Application
		String url = hostAppSp + MAIN_PAGE;
		return url;
	}

	public String getIdpLoginPageUrl(String source) {

		//create url to login.jsp on the IdP part of the Sample Application
		String url = hostAppIdp + JSP_LOGIN + source;
		return url;
	}

	public String getIdpDefaultPageUrl() {

		//create url to index.jsp on the IdP part of the Sample Application
		String url = hostAppIdp + JSP_DEFAULT;
		return url;
	}

	public String getSpDefaultPageUrl() {

		//create url to index.jsp on the SP part of the Sample Application
		String url = hostAppSp + JSP_DEFAULT;
		return url;
	}

	public String getSpLoginPageUrl(String source) {

		//create url to login.jsp on the SP part of the Sample Application
		String url = hostAppSp + JSP_LOGIN + source;
		return url;
	}

	public String getSpAccountLinkingPageUrl(String source) {

		//create url to accountlink.jsp on the SP part of the Sample Application
		String url = hostAppSp + JSP_ACCOUNT_LINK + source;
		return url;
	}

	public String getResumePathUrl(String resumePath) {
		//create the full resumePath based on config properties
		String url = hostPF + resumePath;
		return url;
	}

	public String getSpDefederateUrl() {
		//create url to defederate service
		String url = hostPF + SP_DEFEDERATE;
		return url;
	}

	public String addIdpInErrorResource(String url, String message) {
		char mark = (url.indexOf('?') != -1) ? '&' : '?';
		String newURL = url + mark + IN_ERROR_RESOURCE + '=' +
				getIdpErrorPageUrl() + message;
		return newURL;
	}

	public String addSpInErrorResource(String url, String message) {
		char mark = (url.indexOf('?') != -1) ? '&' : '?';
		String newURL = url + mark + IN_ERROR_RESOURCE + '=' +
				getSpErrorPageUrl() + message;
		return newURL;
	}

	private String addParameters(Boolean forceAuthn, Boolean isPassive) {

		//create string with parameters to be added to url
	   String params = null;
	   if(forceAuthn != null && isPassive == null) {
	      params = "ForceAuthn=" + forceAuthn.toString();   //$NON-NLS-1$
	   }
	   if(forceAuthn == null && isPassive != null) {
	      params = "IsPassive=" + isPassive.toString();     //$NON-NLS-1$
	   }
	   if(forceAuthn != null && isPassive != null) {
	      params = "ForceAuthn=" + forceAuthn.toString() +  //$NON-NLS-1$
	         "&IsPassive=" + isPassive.toString();          //$NON-NLS-1$
	   }
	   return params;
	}

	/**
	 * getProperties method returns all properties in a given file
	 * @param fileName
	 * 				Filename to retreive properties from
	 * @return Properties
	 * 				All properties in the input filename
	 */
    public Properties getProperties(String fileName) throws IOException {
   	 if(fileName == null) {
   		 throw new NullPointerException("fileName parameter cannot be null.");
       }
   	 FileInputStream fis = new FileInputStream(fileName);
       Properties users = new Properties();
       if(fis != null) {
      	 users.load(fis);
      	 fis.close();
       }
       else {
          throw new IOException("Unable to find resource properties file: " + fileName);
       }
       return users;
    }

	/**
	 * getListValues method parses a comma-separated string and return the individual
	 * values in an array
	 * @param listString
	 * 				comma-separated list
	 * @return ArrayList
	 * 				List of individual list items
	 */
	public ArrayList getListValues(String listString) throws IOException {
		// Get Attribute Names List
		ArrayList listItems = new ArrayList();

	   int pos = listString.indexOf(',');
		while( pos != -1 ) {
			String item = listString.substring(0,pos);
			listItems.add(item);
			listString= listString.substring(pos + 1, listString.length());
			pos = listString.indexOf(",");
		}

		listItems.add(listString);

		return listItems;
	}

	/**
	 * authenticateUser method retrieves the username and password from
	 * request. These values are authenticated against the parameters in
	 * servlet configuration. If the authentication is successful, the
	 * user information map is created with additional attributes and returned
	 * @param userName
	 * 				username in request
	 * @param password
	 * 				password in request
	 * @return Map
	 * 				Map of user attributes (username)
	 */
	protected Map authenticateUser(String userName, String password) throws IOException {

      	Properties configProperties = getProperties(configFilePath);

		// Get Attribute Names List
		String attributes = configProperties.getProperty(ATTRIBUTE_NAMES_LIST);
		ArrayList attributeNamesList = getListValues(attributes);

		Map userInfo = null;
		Properties userPassProps;

		userPassProps = getProperties(usersFilePath);


		// Get Attribute Values
		String attributeValues = userPassProps.getProperty(userName);

		if(attributeValues == null) {
			return userInfo;
		}

		// Get password
		String credentials;
		int pos = 0;
		pos = attributeValues.indexOf(',');
		if(pos != -1) {
			credentials= attributeValues.substring(0,pos);
			attributeValues = attributeValues.substring(pos + 1,attributeValues.length());
		}
		else {
			credentials= attributeValues;
		}

		if (credentials!= null && credentials.equals(password)) {

			// Create a user information map and add username
			userInfo = new HashMap();
			userInfo.put(USER_ID, userName);

			// Get Attribute Values List
			ArrayList attributeValuesList = getListValues(attributeValues);

			if(attributes.indexOf(',') != -1) {
				for (int index = 1; index < attributeNamesList.size(); index++) {
					String attributeName = (String)attributeNamesList.get(index);
					String attributeValue = (String)attributeValuesList.get(index - 1);
					userInfo.put(attributeName, attributeValue);
				}
			}

		}
		return userInfo;
	}

	public String displayAuthnContext(String authnContext)
	{
		String DisplayName = null;
		if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:InternetProtocol")) {
			DisplayName = "IP";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:InternetProtocolPassword")) {
			DisplayName = "IP_PASSWORD";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:Kerberos")) {
			DisplayName = "KERBEROS";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:MobileOneFactorUnregistered")) {
			DisplayName = "MOBILE_ONE_FACTOR_UNREGISTERED";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:MobileTwoFactorUnregistered")) {
			DisplayName = "MOBILE_TWO_FACTOR_UNREGISTERED";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:MobileOneFactorContract")) {
			DisplayName = "MOBILE_ONE_FACTOR_CONTRACT";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:MobileTwoFactorContract")) {
			DisplayName = "MOBILE_TWO_FACTOR_CONTRACT";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:Password")) {
			DisplayName = "PASSWORD";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:PasswordProtectedTransport")) {
			DisplayName = "PASSWORD_PROTECTED_TRANSPORT";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:PreviousSession")) {
			DisplayName = "PREVIOUS_SESSION";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:X509")) {
			DisplayName = "X509";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:PGP")) {
			DisplayName = "PGP";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:SPKI")) {
			DisplayName = "SPKI";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:XMLDSig")) {
			DisplayName = "XMLDSIG";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:Smartcard")) {
			DisplayName = "SMARTCARD";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:SmartcardPKI")) {
			DisplayName = "SMARTCARD_PKI";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:SoftwarePKI")) {
			DisplayName = "SOFTWARE_PKI";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:Telephony")) {
			DisplayName = "TELEPHONY";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:NomadTelephony")) {
			DisplayName = "NOMAD_TELEPHONY";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:PersonalTelephony")) {
			DisplayName = "PERSONAL_TELEPHONY";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:AuthenticatedTelephony")) {
			DisplayName = "AUTHENTICATED_TELEPHONY";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:SecureRemotePassword")) {
			DisplayName = "SECURE_REMOTE_PASSWORD";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:TLSClient")) {
			DisplayName = "TLS_CLIENT";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:TimeSyncToken")) {
			DisplayName = "TIME_SYNC_TOKEN";
		}
		else if(authnContext.equals("urn:oasis:names:tc:SAML:2.0:ac:classes:unspecified")) {
			DisplayName = "UNSPECIFIED";
		}
		else {
			DisplayName = authnContext;
		}
		return DisplayName;
	}


	public void setupSpList(HttpServletRequest request)
	{
		HttpSession session = request.getSession(false);
		List spList = getConnectionEntityList(request, WS_METHOD_GETSPLIST);

			Iterator iterator = spList.iterator();
			while( iterator.hasNext() ) {
				String spName = iterator.next().toString();
				System.out.println(spName);
			}


		request.setAttribute(ATTRIB_NAME_SPLIST, spList);
		session.setAttribute(ATTRIB_NAME_SPLIST, spList);
	}    

	public void setupIdpList(HttpServletRequest request)
	{
		HttpSession session = request.getSession(false);
		List idpList = getConnectionEntityList(request, WS_METHOD_GETIDPLIST);

			Iterator iterator = idpList.iterator();
			while( iterator.hasNext() ) {
				String idpName = iterator.next().toString();
				System.out.println(idpName);
			}


		request.setAttribute(ATTRIB_NAME_IDPLIST, idpList);
		session.setAttribute(ATTRIB_NAME_IDPLIST, idpList);
	}    
    
	private List getConnectionEntityList(HttpServletRequest request, String method)  
	{
		ArrayList entityList = new ArrayList(); 
		try
		{
			String wsUrlStr = hostPF + WS_URI;
			System.out.println(wsUrlStr);
			URL serviceUrl = new URL(wsUrlStr);
			Call call = (Call) service.createCall();
			call.setTargetEndpointAddress( serviceUrl );
			call.setOperationName( new QName(NAMESPACE_PFWS, method) );
			QName ssoEntryQName = new QName(NAMESPACE_AXIS_BEAN_SERVICE, SSOENTITY);
			call.registerTypeMapping(SSOEntity.class, ssoEntryQName,
			new org.apache.axis.encoding.ser.BeanSerializerFactory(SSOEntity.class, ssoEntryQName),        
			new org.apache.axis.encoding.ser.BeanDeserializerFactory(SSOEntity.class, ssoEntryQName));

           
			Object result = call.invoke(new Object[]{});

			if (result instanceof SSOEntity[])
			{
				SSOEntity[] entityArray = (SSOEntity[])result;
				for (int i = 0; i < entityArray.length; i++)
				{
					SSOEntity entity = (SSOEntity) entityArray[i]; 
					System.out.println("each entityArray");
					System.out.println(entity);
					System.out.println(entity.getEntityId());
					entityList.add(entity.getEntityId());
				}
			}
			else
			{
				request.setAttribute(ATTRIB_NAME_ERROR, 
					"Received problem response from server: " + result);
			}
		}
		catch (ServiceException ex)
		{
			request.setAttribute(ATTRIB_NAME_ERROR, ex.getMessage());
		}
		catch (RemoteException ex)
		{
			request.setAttribute(ATTRIB_NAME_ERROR, ex.getMessage());
		}
		catch (MalformedURLException ex)
		{
			request.setAttribute(ATTRIB_NAME_ERROR, ex.getMessage());
		}
        
		return entityList;
	}        

%>




